/*
NAIVE SOLUTION:

#include <stdio.h>

int Left[100000];
int Right[100000];
int Top[100000];
int Bottom[100000];

int Count(int x, int y, int n)
{
    int count = 0;
    for (int i = 0; i < n; ++i) {
        if (Left[i] <= x && x <= Right[i])
            ++count;
        else if (Top[i] <= y && y <= Bottom[i])
            ++count;
    }
    return count;
}

int main()
{
    int n, m;
    scanf("%i%i", &n, &m);

    for (int i = 0; i < n; ++i) {
        scanf("%i%i", Left + i, Right + i);
        scanf("%i%i", Top + i, Bottom + i);
    }

    for (int i = 0; i < m; ++i) {
        int x, y;
        scanf("%i%i", &x, &y);
        int count = Count(x, y, n);
        printf("%i\n", count);
    }

    return 0;
}

*/


#include <stdio.h>
#include <stdlib.h>

int MinX[100000];
int MaxX[100000];
int MinY[100000];
int MaxY[100000];

typedef struct {
    int x, y;
    int index;
} Point;
Point Points[100000];
int Count[100000];

int AscY[300000];
int yN;

typedef struct {
    int x;
    int minY, maxY;
} Line;
Line StartLines[100000];
Line EndLines[100000];

int linen;
int BIT[300002];

void IncreaseSum(int x)
{
    while (x <= yN + 1) {
        BIT[x]++;
        x += (x & (-x));
    }
}

void DecreaseSum(int x)
{
    while (x <= yN + 1) {
        BIT[x]--;
        x += (x & (-x));
    }
}

void Increase(int left, int right)
{
    IncreaseSum(left);
    DecreaseSum(right + 1);
}

void Decrease(int left, int right)
{
    DecreaseSum(left);
    IncreaseSum(right + 1);
}

int Get(int x)
{
    if (x <= 0)
        return 0;

    int sum = 0;

    while (x > 0) {
        sum += BIT[x];
        x -= (x & (-x));
    }

    return sum;
}

int CmpAsc(const void* a, const void* b)
{
    return (*(int*)a - *(int*)b);
}

void SortAsc(int* A, int n)
{
    qsort(A, n, sizeof(int), CmpAsc);
}

int CountLess(int* A, int left, int right, int x)
{
    if (left > right) {
        return 0;
    } else if (left == right) {
        return (A[left] < x);
    } else {
        int middle = (left + right) / 2;
        if (A[middle] < x)
            return (middle - left + 1) + CountLess(A, middle + 1, right, x);
        else
            return CountLess(A, left, middle - 1, x);
    }
}

int CountMore(int* A, int left, int right, int x)
{
    if (left > right) {
        return 0;
    } else if (left == right) {
        return (A[left] > x);
    } else {
        int middle = (left + right) / 2;
        if (A[middle] > x)
            return CountMore(A, left, middle - 1, x) + (right - middle + 1);
        else
            return CountMore(A, middle + 1, right, x);
    }
}

int IdY(int y)
{
    return 1 + CountLess(AscY, 0, yN - 1, y);
}

int CountLines(int x, int y, int n)
{
    int lessX = CountLess(MaxX, 0, n - 1, x);
    int moreX = CountMore(MinX, 0, n - 1, x);
    int countX = n - lessX - moreX;

    int lessY = CountLess(MaxY, 0, n - 1, y);
    int moreY = CountMore(MinY, 0, n - 1, y);
    int countY = n - lessY - moreY;

    return (countX + countY);
}

int CmpPoint(const void* a, const void* b)
{
    const Point* pointA = a;
    const Point* pointB = b;
    return (pointA->x - pointB->x);
}

int CmpLine(const void* a, const void* b)
{
    const Line* lineA = a;
    const Line* lineB = b;
    return (lineA->x - lineB->x);
}

int Min3(int a, int b, int c)
{
    if (b < a)
        a = b;
    if (c < a)
        a = c;
    return a;
}

int main()
{
    int rectn, pointn;
    scanf("%i%i", &rectn, &pointn);
    int i;
    for (i = 0; i < rectn; ++i) {
        scanf("%i%i", MinX + i, MaxX + i);
        scanf("%i%i", MinY + i, MaxY + i);

        StartLines[i].x = MinX[i];
        StartLines[i].minY = MinY[i];
        StartLines[i].maxY = MaxY[i];

        EndLines[i].x = MaxX[i];
        EndLines[i].minY = MinY[i];
        EndLines[i].maxY = MaxY[i];

        AscY[yN++] = MinY[i];
        AscY[yN++] = MaxY[i];
    }

    SortAsc(MinX, rectn);
    SortAsc(MaxX, rectn);
    SortAsc(MinY, rectn);
    SortAsc(MaxY, rectn);

    for (i = 0; i < pointn; ++i) {
        Point* point = Points + i;
        scanf("%i%i", &point->x, &point->y);
        point->index = i;

        Count[i] = CountLines(point->x, point->y, rectn);

        AscY[yN++] = point->y;
    }

    qsort(AscY, yN, sizeof(int), CmpAsc);
    int newyN = 1;
    for (i = 1; i < yN; ++i) {
        if (AscY[i - 1] < AscY[i])
            AscY[newyN++] = AscY[i];
    }
    yN = newyN;

    linen = rectn;
    qsort(Points, pointn, sizeof(Point), CmpPoint);
    qsort(StartLines, linen, sizeof(Line), CmpLine);
    qsort(EndLines, linen, sizeof(Line), CmpLine);

    for (i = 0; i < linen; ++i) {
        StartLines[i].minY = IdY(StartLines[i].minY);
        StartLines[i].maxY = IdY(StartLines[i].maxY);

        EndLines[i].minY = IdY(EndLines[i].minY);
        EndLines[i].maxY = IdY(EndLines[i].maxY);
    }

    for (i = 0; i < pointn; ++i) {
        Points[i].y = IdY(Points[i].y);
    }

    int pointi = 0;
    int starti = 0;
    int endi = 0;
    while (1) {
        int pointx = 1000000000;
        if (pointi < pointn)
            pointx = Points[pointi].x;

        int startx = 1000000000;
        if (starti < linen)
            startx = StartLines[starti].x;

        int endx = 1000000000;
        if (endi < linen)
            endx = EndLines[endi].x;

        int minx = Min3(pointx, startx, endx);
        if (minx == 1000000000)
            break;

        if (minx == startx) {
            Increase(StartLines[starti].minY, StartLines[starti].maxY);
            starti++;
        } else if (minx == pointx) {
            int index = Points[pointi].index;
            Count[index] -= Get(Points[pointi].y);
            pointi++;
        } else if (minx == endx) {
            Decrease(EndLines[endi].minY, EndLines[endi].maxY);
            endi++;
        }
    }

    for (i = 0; i < pointn; ++i)
        printf("%i\n", Count[i]);

    return 0;
}
