#include <iostream>
#include <fstream>
#include <stdlib.h>

using namespace std;
typedef struct{
    int fok, szin, d, apa, nr_d, *lista, *elodok, nr_elod, *utodok, nr_utod;
}NODE;


void bfs(int, NODE*, double**, double**, int);

int main()
{
    ifstream fin("SmartCity.in");
    int T, n, m, a, b;
    NODE *szl;
    double **szm, **traffic;
    fin >> T;
    for( int t = 1 ; t <= T ; ++t ){
        fin >> n >> m;
        szl = (NODE*)calloc(n+1,sizeof(NODE));
        szm = (double**)calloc(n+1, sizeof(double*));
        traffic = (double**)calloc(n+1, sizeof(double*));
        for( int i = 1 ; i <= n ; ++i ){
            szl[i].lista = (int*)calloc(n+1, sizeof(int));
            szl[i].elodok = (int*)calloc(n+1, sizeof(int));
            szl[i].utodok = (int*)calloc(n+1, sizeof(int));
            szm[i] = (double*)calloc(n+1, sizeof(double));
            traffic[i] = (double*)calloc(n+1, sizeof(double));
        }
        for( int i = 1 ; i <= m ; ++i ){
            fin >> a >> b;
            szm[a][b] = szm[b][a] = 1;
            ++szl[a].fok;
            szl[a].lista[szl[a].fok] = b;
            ++szl[b].fok;
            szl[b].lista[szl[b].fok] = a;
        }
/*
        cout << "\nszomszedsagi lista\n";
        for( int i = 1 ; i <= n ; ++i ){
            cout << i << ": ";
            for( int j = 1 ; j <= szl[i].fok ; ++j ){
                cout << szl[i].lista[j] << ' ';
            }
            cout << '\n';
        }
*/
        for( int p = 1 ; p <= n ; ++p ){
            //cout << "\nszelessegi sorrend\n";
            bfs(n, szl, szm, traffic, p);

            //cout << "\nforgalom ertekek\n";
            for( int i = 1 ; i <= n ; ++i ){
                for( int j = 1 ; j <= szl[i].fok ; ++j ){
                    int jj = szl[i].lista[j];
                    if (i < jj) {
                        traffic[i][jj] += szm[i][jj];
                        traffic[jj][i] = traffic[i][jj];
                        //cout << "(" << i << "," << jj << ") [" << traffic[i][jj] << " ]\n";
                        szm[i][jj] = szm[jj][i] = 1;
                    }
                }
            }
        }
        int maxtraffic = -1, maxx, maxy;
        for( int i = 1 ; i <= n ; ++i ){
            for( int j = 1 ; j <= szl[i].fok ; ++j ){
                int jj = szl[i].lista[j];
                if ( traffic[i][jj] >  maxtraffic ) {
                    maxtraffic = traffic[i][jj];
                    maxx = i; maxy = jj;
                    //cout << "(" << i << "," << jj << ") [" << traffic[i][jj] / 2 << " ]\n";
                }
            }
        }
        cout << maxtraffic / 2 << ' ' << maxx << ' ' << maxy << '\n';

        for( int i = 1 ; i <= n ; ++i ){
            free(szl[i].lista);
            free(szl[i].elodok);
            free(szl[i].utodok);
            free(szm[i]);
            free(traffic[i]);
        }
        free(szl);
        free(szm);
        free(traffic);
    }

/*
    cout << "\nlegrovidebb utak hosszai\n";
    for( int i = 1 ; i <= n ; ++i ){
        cout << i << ": " << szl[i].d << "(" << szl[i].nr_d << ")[ ";
        for( int j = 1 ; j <= szl[i].nr_elod ; ++j ){
            cout << szl[i].elodok[j] << ' ';
        }
        cout << "]\n";
    }
*/
/*
    for( int i = 1 ; i <= n ; ++i ){
        for( int j = 1 ; j <= n ; ++j ){
            cout << szm[i][j] << ' ';
        }
        cout << "\n";
    }
*/
    fin.close();
    return 0;
}

void bfs(int n, NODE *szl, double **szm, double **traffic, int u){
    int *q = (int*)calloc(n+1, sizeof(int));
    for( int i = 1 ; i <= n ; ++i ){
         szl[i].apa = 0;
         szl[i].szin = 0;
         szl[i].d = 0;
         szl[i].nr_d = 0;
         szl[i].nr_elod = 0;
         szl[i].nr_utod = 0;
         for( int j = 1 ; j <= n ; ++j ){
             szm[i][j] = 0;
         }
    }
    q[0] = u;
    szl[u].szin = 1;
    szl[u].nr_d = 1;
    int eleje = 0, vege = 1, x, y;
    while( eleje < vege){
        x = q[eleje];
        //cout << x << ' ';
        for( int i = 1 ; i <= szl[x].fok ; ++i ){
            y = szl[x].lista[i];
            if( szl[y].szin == 0 ){
                szl[y].apa = x;
                szl[y].szin = 1;
                szl[y].d = szl[x].d + 1;
                szl[y].nr_d += szl[x].nr_d;
                ++szl[y].nr_elod; szl[y].elodok[szl[y].nr_elod] = x;
                ++szl[x].nr_utod; szl[x].utodok[szl[x].nr_utod] = y;
                q[vege++] = y;
            }
            else{
                if(szl[y].szin == 1){
                    if(szl[y].d == szl[x].d + 1){
                        szl[y].nr_d += szl[x].nr_d;
                        ++szl[y].nr_elod; szl[y].elodok[szl[y].nr_elod] = x;
                        ++szl[x].nr_utod; szl[x].utodok[szl[x].nr_utod] = y;
                    }
                }
            }
        }
        szl[x].szin = 2;
        ++eleje;
    }
    for( int i = n-1 ; i >= 0 ; --i ){
        x = q[i];
        float kiosszeg = 0;
        for( int j = 1 ; j <= szl[x].nr_utod ; ++j ){
            y = szl[x].utodok[j];
            kiosszeg += szm[x][y];
        }
        ++kiosszeg;
        int beutak = 0;
        for( int j = 1 ; j <= szl[x].nr_elod ; ++j ){
            y = szl[x].elodok[j];
            beutak += szl[y].nr_d;
        }
        for( int j = 1 ; j <= szl[x].nr_elod ; ++j ){
            y = szl[x].elodok[j];
            szm[y][x] = szm[x][y] = kiosszeg * ((double)szl[y].nr_d / beutak);
        }
        //traffic[x][y] += szm[x][y];
        //traffic[y][x] = traffic[x][y];
    }
}
