#include <stdio.h>
#include <math.h>

#define NMax 1010
#define INF 2000000000
#define KMax 55

int dx[8] = {-1, -1, -1, 0, 0, +1, +1, +1};
int dy[8] = {-1, 0, +1, -1, +1, -1, 0, +1};

typedef struct slot {
	int x, y, a;
} slot;

slot s[KMax];

double danger[NMax][NMax];
int N, M, K, T;

int dmin[NMax][NMax];
int in, sf, cx[NMax * NMax], cy[NMax * NMax];

int goToWedding(double dangerBound) {

	for (int i = 0; i <= N+1; i++) {
		for (int j = 0; j <= M+1; j++) {
			dmin[i][j] = INF;
		}
	}
	in = sf = 0;
	cx[0] = 1; cy[0] = 1;
	dmin[cx[0]][cy[0]] = 0;

	while (in <= sf) {
		for (int i = 0; i < 8; i++ ) if (danger[cx[in] + dx[i]][cy[in] + dy[i]] < dangerBound &&
			dmin[cx[in] + dx[i]][cy[in] + dy[i]] > dmin[cx[in]][cy[in]] + 1) {

			dmin[cx[in] + dx[i]][cy[in] + dy[i]] = dmin[cx[in]][cy[in]] + 1;
			sf++;
			cx[sf] = cx[in] + dx[i];
			cy[sf] = cy[in] + dy[i];
		}
		in++;
	}
	return dmin[N][M];
}

int main() {
	freopen("wedding.in", "r", stdin);
	freopen("wedding.out", "w", stdout);

	scanf("%d %d %d %d", &N, &M, &K, &T);

	// margins
	for (int i = 0; i <= M + 1; i++) { danger[0][i] = danger[N+1][i] = INF; }
	for (int i = 0; i <= N + 1; i++) { danger[i][0] = danger[i][M+1] = INF; }


	// read slots
	for (int si = 0; si < K; si++) {
		scanf("%d %d %d\n", &s[si].x, &s[si].y, &s[si].a);
		for (int i = 1; i <= N; i++) {
			for (int j = 1; j <= M; j++) {
				if (s[si].x == i && s[si].y == j) { continue; }
				danger[i][j] += (double) s[si].a * (N + M) / (abs(s[si].x - i) + abs(s[si].y - j));
			}
		}
	}

	
	for (int si = 0; si < K; si++) {
		danger[s[si].x][s[si].y] = INF;
	}

	double danMax = 0;

	for (int i = 1; i <= N; i++) {
		for (int j = 1; j <= M; j++) {
			if (danMax < danger[i][j]) {
				danMax = danger[i][j];
			}
			//printf("%5.5lf    ", danger[i][j]);
		}
		//printf("\n");
	}

	double l = 0, r = danMax, m;
	while (r - l > 1e-5) {
		m = (l + r) / 2;
		int steps = goToWedding(m);
		if (steps <= T) {
			r = m;
		} else {
			l = m;
		}
	}

	printf("%.3lf\n", m);

	fclose(stdout);
	return 0;

}
